diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesEucalyptus.java b/src/main/java/net/minecraft/core/block/EucalyptusLeavesBlock.java
similarity index 59%
rename from src/main/java/net/minecraft/core/block/BlockLeavesEucalyptus.java
rename to src/main/java/net/minecraft/core/block/EucalyptusLeavesBlock.java
index a0cfebe4b..dd0e431a8 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesEucalyptus.java
+++ b/src/main/java/net/minecraft/core/block/EucalyptusLeavesBlock.java
@@ -6,27 +6,27 @@ import net.minecraft.core.block.material.Material;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockLeavesBase, Material, ColorizerFoliage, IBlockAccess, 
-//            WorldChunkManager, World, Block, EntityPlayer, 
+//            BaseLeavesBlock, Material, ColorizerFoliage, IBlockAccess,
+//            WorldChunkManager, World, Block, Player,
 //            ItemStack, Item, ItemShears, StatList, 
 //            Entity
 
-public class BlockLeavesEucalyptus extends BlockLeavesBase
+public class EucalyptusLeavesBlock extends BaseLeavesBlock
 {
 
-	public BlockLeavesEucalyptus(String key, int id)
+	public EucalyptusLeavesBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.leaves);
+        super(key, namespaceId, id, Material.leaves);
     }
 
     @Override
     protected Block getSapling()
     {
-        return Block.saplingEucalyptus;
+        return Blocks.SAPLING_EUCALYPTUS;
     }
 
     @Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand)
+	public void animationTick(World world, int x, int y, int z, Random rand)
     {
     	if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasFallingLeaves && rand.nextInt(40) == 0)
     	{
diff --git a/src/main/java/net/minecraft/core/block/BlockFarmland.java b/src/main/java/net/minecraft/core/block/FarmlandBlock.java
similarity index 74%
rename from src/main/java/net/minecraft/core/block/BlockFarmland.java
rename to src/main/java/net/minecraft/core/block/FarmlandBlock.java
index ccc8ef0fd..7f05ff384 100644
--- a/src/main/java/net/minecraft/core/block/BlockFarmland.java
+++ b/src/main/java/net/minecraft/core/block/FarmlandBlock.java
@@ -1,13 +1,13 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
@@ -16,13 +16,11 @@ import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
-public class BlockFarmland
-	extends Block
-	implements IBonemealable
+public class FarmlandBlock extends Block implements IBonemealable
 {
-	public BlockFarmland(String key, int id)
+	public FarmlandBlock(String key, String namespaceId, int id)
 	{
-		super(key, id, Material.dirt);
+		super(key, namespaceId, id, Material.dirt);
 		setTicking(true);
 		setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.9375F, 1.0F);
 		withLightBlock(255);
@@ -48,11 +46,11 @@ public class BlockFarmland
 	@Override
 	public AABB getCollisionBoundingBoxFromPool(final WorldSource world, final int x, final int y, final int z)
 	{
-		return AABB.getBoundingBoxFromPool(x + 0, y + 0, z + 0, x + 1, y + 1, z + 1);
+		return AABB.getTemporaryBB(x + 0, y + 0, z + 0, x + 1, y + 1, z + 1);
 	}
 
 	@Override
-	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
 	{
 		switch (dropCause)
 		{
@@ -61,9 +59,9 @@ public class BlockFarmland
 				return new ItemStack[] { new ItemStack(this) };
 			default:
 				if(isWet(world.getBlockMetadata(x, y, z))){
-					return new ItemStack[] { new ItemStack(Block.mud) };
+					return new ItemStack[] { new ItemStack(Blocks.MUD) };
 				} else {
-					return new ItemStack[] { new ItemStack(Block.dirt) };
+					return new ItemStack[] { new ItemStack(Blocks.DIRT) };
 				}
 		}
 
@@ -75,7 +73,7 @@ public class BlockFarmland
 		{
 			for (int iz = z - radius; iz <= z + radius; iz++)
 			{
-				if (world.getBlockId(ix, y + 1, iz) == Block.cropsWheat.id)
+				if (world.getBlockId(ix, y + 1, iz) == Blocks.CROPS_WHEAT.id)
 				{
 					return true;
 				}
@@ -118,16 +116,15 @@ public class BlockFarmland
 	{
 		if (world.rand.nextInt(4) == 0)
 		{
-			if (entity instanceof EntityPlayer)
+			if (entity instanceof Player)
 			{
-				if (((EntityPlayer) entity).inventory.armorInventory[0] != null && ((EntityPlayer) entity).inventory.armorInventory[0].getItem() == Item.armorBootsLeather)
-				{
+				if (((Player) entity).inventory.armorInventory[0] != null && ((Player) entity).inventory.armorInventory[0].getItem() == Items.ARMOR_BOOTS_LEATHER) {
 					return;
 				}
 				if(isWet(world.getBlockMetadata(x, y, z)))
-					world.setBlockWithNotify(x, y, z, Block.mud.id);
+					world.setBlockWithNotify(x, y, z, Blocks.MUD.id);
 				else
-					world.setBlockWithNotify(x, y, z, Block.dirt.id);
+					world.setBlockWithNotify(x, y, z, Blocks.DIRT.id);
 
 			}
 		}
@@ -141,15 +138,15 @@ public class BlockFarmland
 		if (material.isSolid())
 		{
 			if(isWet(world.getBlockMetadata(x, y, z)))
-				world.setBlockWithNotify(x, y, z, Block.mud.id);
+				world.setBlockWithNotify(x, y, z, Blocks.MUD.id);
 			else
-				world.setBlockWithNotify(x, y, z, Block.dirt.id);
+				world.setBlockWithNotify(x, y, z, Blocks.DIRT.id);
 
 		}
 	}
 
 	@Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
 	{
 		return false;
 	}
@@ -165,14 +162,14 @@ public class BlockFarmland
 					int newData = ((data & 0x0F) - 1) | (data & 0xF0);
 					world.setBlockMetadataWithNotify(x, y, z, newData);
 				} else if (!isCropsNearby(world, x, y, z)) {
-					world.setBlockWithNotify(x, y, z, Block.dirt.id);
+					world.setBlockWithNotify(x, y, z, Blocks.DIRT.id);
 				}
 			}
 		}
 	}
 
 	@Override
-	public boolean onBonemealUsed(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		int data = world.getBlockMetadata(blockX, blockY, blockZ);
 		if (!isFertilized(data)) {
 			world.setBlockMetadataWithNotify(blockX, blockY, blockZ, setFertilized(data, true));
diff --git a/src/main/java/net/minecraft/core/block/BlockFence.java b/src/main/java/net/minecraft/core/block/FenceBlock.java
similarity index 88%
rename from src/main/java/net/minecraft/core/block/BlockFence.java
rename to src/main/java/net/minecraft/core/block/FenceBlock.java
index f8290710b..c1b5f735c 100644
--- a/src/main/java/net/minecraft/core/block/BlockFence.java
+++ b/src/main/java/net/minecraft/core/block/FenceBlock.java
@@ -10,7 +10,7 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.WorldSource;
 
 
-public class BlockFence extends Block
+public class FenceBlock extends Block
 {
 //    private static final List<BoundingVolume> selectionVolumes = new ArrayList<>();
 //
@@ -56,9 +56,9 @@ public class BlockFence extends Block
 //        selectionVolumes.add(newVolume);
 //    }
 
-    public BlockFence(String key, int id)
+    public FenceBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.wood);
+        super(key, namespaceId, id, Material.wood);
     }
 
     @Override
@@ -74,13 +74,13 @@ public class BlockFence extends Block
     	boolean connectXNeg = canConnectTo(world, x - 1, y, z);
     	boolean connectZPos = canConnectTo(world, x, y, z + 1);
     	boolean connectZNeg = canConnectTo(world, x, y, z - 1);
-        return AABB.getBoundingBoxFromPool(x + (connectXNeg ? 0.0f : 0.375f), y, z + (connectZNeg ? 0.0f : 0.375f), x + 1 - (connectXPos ? 0.0f : 0.375f), (float) y + 1.5F, z + 1 - (connectZPos ? 0.0f : 0.375f));
+        return AABB.getTemporaryBB(x + (connectXNeg ? 0.0f : 0.375f), y, z + (connectZNeg ? 0.0f : 0.375f), x + 1 - (connectXPos ? 0.0f : 0.375f), (float) y + 1.5F, z + 1 - (connectZPos ? 0.0f : 0.375f));
     }
     
     @Override
     public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
-    	return getCollisionBoundingBoxFromPool(world, x, y, z).expand(0, -0.25f, 0).offset(0, -0.25f, 0);
+    	return getCollisionBoundingBoxFromPool(world, x, y, z).grow(0, -0.25f, 0).move(0, -0.25f, 0);
     }
 
 //    @Override
@@ -121,7 +121,7 @@ public class BlockFence extends Block
     }
 
     @Override
-    public boolean renderAsNormalBlock()
+    public boolean isCubeShaped()
     {
         return false;
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockFenceGate.java b/src/main/java/net/minecraft/core/block/FenceGateBlock.java
similarity index 70%
rename from src/main/java/net/minecraft/core/block/BlockFenceGate.java
rename to src/main/java/net/minecraft/core/block/FenceGateBlock.java
index 295482077..0f7dc784c 100644
--- a/src/main/java/net/minecraft/core/block/BlockFenceGate.java
+++ b/src/main/java/net/minecraft/core/block/FenceGateBlock.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.sound.SoundCategory;
@@ -11,18 +11,12 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-
-// updated
-// Referenced classes of package net.minecraft.src:
-//            Block, Material, World, AxisAlignedBB,
-//            EntityLiving, MathHelper, EntityPlayer
-
-public class BlockFenceGate extends Block
+public class FenceGateBlock extends Block
 {
 
-    public BlockFenceGate(String key, int id)
+    public FenceGateBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.wood);
+        super(key, namespaceId, id, Material.wood);
     }
 
     @Override
@@ -34,7 +28,7 @@ public class BlockFenceGate extends Block
             return null;
         } else
         {
-        	return getAABBFromMeta(l).expand(0, 0.25f, 0).offset(x, y + 0.25f, z);
+        	return getAABBFromMeta(l).grow(0, 0.25f, 0).move(x, y + 0.25f, z);
         }
     }
     
@@ -42,11 +36,11 @@ public class BlockFenceGate extends Block
     {
     	if (func_35290_f(meta) == 3 || func_35290_f(meta) == 1)
     	{
-    		return AABB.getBoundingBoxFromPool(0.375f, 0, 0, 1 - 0.375f, 1.0F, 1f);
+    		return AABB.getTemporaryBB(0.375f, 0, 0, 1 - 0.375f, 1.0F, 1f);
     	}
     	else
     	{
-    		return AABB.getBoundingBoxFromPool(0, 0, 0.375f, 1, 1.0f, 1 - 0.375f);
+    		return AABB.getTemporaryBB(0, 0, 0.375f, 1, 1.0f, 1 - 0.375f);
     	}
 
     }
@@ -54,7 +48,7 @@ public class BlockFenceGate extends Block
     @Override
     public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
-    	return getAABBFromMeta(world.getBlockMetadata(x, y, z)).offset(x, y, z);
+    	return getAABBFromMeta(world.getBlockMetadata(x, y, z)).move(x, y, z);
     }
     
     @Override
@@ -77,27 +71,27 @@ public class BlockFenceGate extends Block
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
 
     @Override
-    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
-    	int directionmeta = entity.getHorizontalPlacementDirection(side).getHorizontalIndex();
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    	int directionmeta = mob.getHorizontalPlacementDirection(side).getHorizontalIndex();
         int colormeta = world.getBlockMetadata(x, y, z);
         world.setBlockMetadataWithNotify(x, y, z, directionmeta | (colormeta & 0xF0));
     }
     
     @Override
-	public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit) {
+	public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
     	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
     		onBlockRightClicked(world, x, y, z, player, null, 0.0, 0.0);
     	}
     }
     
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         int l = world.getBlockMetadata(x, y, z);
         if(func_35291_d(l))
@@ -105,7 +99,7 @@ public class BlockFenceGate extends Block
             world.setBlockMetadataWithNotify(x, y, z, l & -5);
         } else
         {
-            int i1 = (MathHelper.floor_double((double)((player.yRot * 4F) / 360F) + 0.5D) & 3) % 4;
+            int i1 = (MathHelper.floor((double)((player.yRot * 4F) / 360F) + 0.5D) & 3) % 4;
             int j1 = func_35290_f(l);
             if(j1 == (i1 + 2) % 4)
             {
diff --git a/src/main/java/net/minecraft/core/block/FireBlock.java b/src/main/java/net/minecraft/core/block/FireBlock.java
new file mode 100644
index 000000000..003eb7883
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/FireBlock.java
@@ -0,0 +1,390 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class FireBlock extends Block {
+	public static final int FLAME_INSTANT = 60;
+	public static final int FLAME_EASY = 30;
+	public static final int FLAME_MEDIUM = 15;
+	public static final int FLAME_HARD = 5;
+	public static final int BURN_INSTANT = 100;
+	public static final int BURN_EASY = 60;
+	public static final int BURN_MEDIUM = 20;
+	public static final int BURN_HARD = 5;
+	public static final int BURN_NEVER = 0;
+	private static final int[] flameChance = new int[Block.blocksList.length];
+	private static final int[] burnChance = new int[Block.blocksList.length];
+
+	public FireBlock(String key, String namespaceId, int id) {
+		super(key, namespaceId, id, Material.fire);
+		setTicking(true);
+		setBlockBounds(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
+	}
+
+	@Override
+	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
+	{
+		return null;
+	}
+
+	@Override
+	public void initializeBlock() {
+		setFlammable(Blocks.PLANKS_OAK.id, FLAME_HARD, BURN_MEDIUM);
+		setFlammable(Blocks.PLANKS_OAK_PAINTED.id, FLAME_HARD, BURN_MEDIUM);
+		setFlammable(Blocks.FENCE_PLANKS_OAK.id, FLAME_HARD, BURN_MEDIUM);
+		setFlammable(Blocks.FENCE_PLANKS_OAK_PAINTED.id, FLAME_HARD, BURN_MEDIUM);
+		setFlammable(Blocks.SLAB_PLANKS_OAK.id, FLAME_HARD, BURN_MEDIUM);
+		setFlammable(Blocks.SLAB_PLANKS_PAINTED.id, FLAME_HARD, BURN_MEDIUM);
+		setFlammable(Blocks.STAIRS_PLANKS_OAK.id, FLAME_HARD, BURN_MEDIUM);
+		setFlammable(Blocks.LOG_OAK.id, FLAME_HARD, BURN_HARD);
+		setFlammable(Blocks.LOG_PINE.id, FLAME_HARD, BURN_HARD);
+		setFlammable(Blocks.LOG_BIRCH.id, FLAME_HARD, BURN_HARD);
+		setFlammable(Blocks.LOG_CHERRY.id, FLAME_HARD, BURN_HARD);
+		setFlammable(Blocks.LOG_OAK_MOSSY.id, FLAME_HARD, BURN_HARD);
+		setFlammable(Blocks.LOG_EUCALYPTUS.id, FLAME_HARD, BURN_HARD);
+		setFlammable(Blocks.LEAVES_OAK.id, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_PINE.id, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_BIRCH.id, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_CHERRY.id, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_CHERRY_FLOWERING.id, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_OAK_RETRO.id, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_SHRUB.id, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_EUCALYPTUS.id, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_CACAO.id, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.BOOKSHELF_PLANKS_OAK.id, FLAME_EASY, BURN_MEDIUM);
+		setFlammable(Blocks.TNT.id, FLAME_MEDIUM, BURN_INSTANT);
+		setFlammable(Blocks.WOOL.id, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.MOSS_STONE.id, 100, 30);
+		setFlammable(Blocks.MOSS_BASALT.id, 100, 30);
+		setFlammable(Blocks.MOSS_LIMESTONE.id, 100, 30);
+		setFlammable(Blocks.MOSS_GRANITE.id, 100, 30);
+	}
+
+	public static void setFlammable(int id, int flameChance, int burnChance) {
+		FireBlock.flameChance[id] = flameChance;
+		FireBlock.burnChance[id] = burnChance;
+	}
+
+	@Override
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
+		return null;
+	}
+
+	@Override
+	public boolean isSolidRender() {
+		return false;
+	}
+
+	@Override
+	public boolean isCubeShaped() {
+		return false;
+	}
+
+	@Override
+	public void onBlockRemoved(World world, int x, int y, int z, int data)
+	{
+		for (int i = 0; i < 8; i++)
+		{
+			world.spawnParticle("largesmoke", (double)x + Math.random(), (double)y + 0.5D, (double)z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
+		}
+	}
+
+	@Override
+	public int tickDelay() {
+		return 40;
+	}
+	
+	public void setBurnResult(World world, int x, int y, int z) {
+		world.setBlockWithNotify(x, y, z, getBurnResultId(world, x, y, z));
+	}
+
+	@Override
+	public void updateTick(World world, int x, int y, int z, Random rand) {
+		Block blockUnder = world.getBlock(x, y - 1, z);
+		boolean infiniBurn = blockUnder != null && blockUnder.hasTag(BlockTags.INFINITE_BURN);
+
+		//Extinguish fire
+		if (!isValidFireLocation(world, x, y, z)) {
+			setBurnResult(world, x, y, z);
+		}
+		
+		//Extinguish fire (Rain / Snow)
+		if (!infiniBurn && world.getCurrentWeather() != null && world.getCurrentWeather().isPrecipitation && (
+				   world.canBlockBeRainedOn(x, y, z)
+				|| world.canBlockBeRainedOn(x - 1, y, z)
+				|| world.canBlockBeRainedOn(x + 1, y, z)
+				|| world.canBlockBeRainedOn(x, y, z - 1)
+				|| world.canBlockBeRainedOn(x, y, z + 1))) {
+			setBurnResult(world, x, y, z);
+			return;
+		}
+		
+		int meta = world.getBlockMetadata(x, y, z);
+		if (meta < 15) {
+			world.setBlockMetadata(x, y, z, meta + rand.nextInt(3) / 2);
+		}
+		world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+		
+		
+		if (!infiniBurn && !canNeighborCatchFire(world, x, y, z)) {
+			if (!world.isBlockNormalCube(x, y - 1, z) || meta > 3) {
+				setBurnResult(world, x, y, z);
+			}
+			return;
+		}
+		
+		if (!infiniBurn && !canBurn(world, x, y - 1, z) && meta == 15 && rand.nextInt(4) == 0) {
+			setBurnResult(world, x, y, z);
+			return;
+		}
+		
+		checkBurn(world, x + 1, y, z, 300, rand, meta);
+		checkBurn(world, x - 1, y, z, 300, rand, meta);
+		checkBurn(world, x, y - 1, z, 250, rand, meta);
+		checkBurn(world, x, y + 1, z, 250, rand, meta);
+		checkBurn(world, x, y, z - 1, 300, rand, meta);
+		checkBurn(world, x, y, z + 1, 300, rand, meta);
+		
+		for (int x1 = x - 1; x1 <= x + 1; x1++) {
+			for (int z1 = z - 1; z1 <= z + 1; z1++) {
+				for (int y1 = y - 1; y1 <= y + 4; y1++) {
+					if (x1 == x && y1 == y && z1 == z) {
+						continue;
+					}
+					
+					int a = 100;
+					if (y1 > y + 1) {
+						a += (y1 - (y + 1)) * 100;
+					}
+					int b = getFireChance(world, x1, y1, z1);
+					if (b <= 0) {
+						continue;
+					}
+					
+					int c = (b + 40) / (meta + 30);
+					if (c <= 0 || rand.nextInt(a) > c || (world.getCurrentWeather() != null && world.getCurrentWeather().isPrecipitation) &&
+							   world.canBlockBeRainedOn(x1, y1, z1)
+							|| world.canBlockBeRainedOn(x1 - 1, y1, z)
+							|| world.canBlockBeRainedOn(x1 + 1, y1, z1)
+							|| world.canBlockBeRainedOn(x1, y1, z1 - 1)
+							|| world.canBlockBeRainedOn(x1, y1, z1 + 1)
+					) {
+						continue;
+					}
+					
+					if(getBurnResultId(world, x1, y1, z1) == 0 /* Fix for fire destroying moss blocks */) {
+						//Spread Fire with higher meta
+						world.setBlockAndMetadataWithNotify(x1, y1, z1, id, Math.min(meta + rand.nextInt(5) / 4, 15));
+					}
+				}
+
+			}
+
+		}
+
+	}
+
+	private void checkBurn(World world, int x, int y, int z, int chance, Random random, int meta) {
+		if (random.nextInt(chance) < burnChance[world.getBlockId(x, y, z)]) {
+			boolean isTNT = world.getBlockId(x, y, z) == Blocks.TNT.id;
+			
+			if (random.nextInt(meta + 10) < 5 && !world.canBlockBeRainedOn(x, y, z)) {
+				if(getBurnResultId(world, x, y, z) == 0 /* Fix for fire destroying moss blocks */) {
+					//Spread Fire with higher meta
+					world.setBlockAndMetadataWithNotify(x, y, z, id, Math.min(meta + random.nextInt(5) / 4, 15));
+				}
+			} else {
+				setBurnResult(world, x, y, z);
+			}
+			
+			if (isTNT) {
+				TNTBlock TNTBlock = (TNTBlock) Blocks.TNT;
+				TNTBlock.ignite(world, x, y, z, true);
+			}
+		}
+	}
+
+	private boolean canNeighborCatchFire(World world, int x, int y, int z) {
+		if (canBurn(world, x + 1, y, z)) return true;
+		if (canBurn(world, x - 1, y, z)) return true;
+		if (canBurn(world, x, y - 1, z)) return true;
+		if (canBurn(world, x, y + 1, z)) return true;
+		if (canBurn(world, x, y, z - 1)) return true;
+        return canBurn(world, x, y, z + 1);
+    }
+
+	private int getFireChance(World world, int x, int y, int z) {
+		int flammability = 0;
+		if (!world.isAirBlock(x, y, z)) {
+			return 0;
+		} else {
+			flammability = getFlammability(world, x + 1, y, z, flammability);
+			flammability = getFlammability(world, x - 1, y, z, flammability);
+			flammability = getFlammability(world, x, y - 1, z, flammability);
+			flammability = getFlammability(world, x, y + 1, z, flammability);
+			flammability = getFlammability(world, x, y, z - 1, flammability);
+			flammability = getFlammability(world, x, y, z + 1, flammability);
+			return flammability;
+		}
+	}
+
+	public static boolean canBurn(WorldSource worldSource, int x, int y, int z) {
+		return flameChance[worldSource.getBlockId(x, y, z)] > 0;
+	}
+	public static boolean canBurn(int blockId) {
+		return flameChance[blockId] > 0;
+	}
+
+	public static int getFlammability(World world, int x, int y, int z, int currentFlameChance) {
+		int blockFlameChance = flameChance[world.getBlockId(x, y, z)];
+        return Math.max(blockFlameChance, currentFlameChance);
+	}
+	
+	public boolean isValidFireLocation(World world, int x, int y, int z) {
+		return world.isBlockNormalCube(x, y - 1, z) || canNeighborCatchFire(world, x, y, z); 
+	}
+
+	@Override
+	public boolean canPlaceBlockAt(World world, int x, int y, int z) {
+		return isValidFireLocation(world, x, y, z);
+	}
+
+	@Override
+	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
+		if (!world.isBlockNormalCube(x, y - 1, z) && !canNeighborCatchFire(world, x, y, z)) {
+
+			world.setBlockWithNotify(x, y, z, getBurnResultId(world, x, y, z));
+        }
+	}
+
+	protected int getBurnResultId(World world, int x, int y, int z) {
+		int id = world.getBlockId(x, y, z);
+		Block stoneBlock = MossBlock.getStoneBlock(id);
+		if (stoneBlock != null) {
+			return stoneBlock.id;
+		}
+		return 0;
+	}
+
+	@Override
+	public void onBlockPlacedByWorld(World world, int x, int y, int z) {
+		if (world.getBlockId(x, y - 1, z) == Blocks.OBSIDIAN.id
+				&& ((PortalBlock) Blocks.PORTAL_NETHER).tryToCreatePortal(world, x, y, z)) {
+			return;
+		}
+		if (!world.isBlockNormalCube(x, y - 1, z) && !canNeighborCatchFire(world, x, y, z)) {
+			world.setBlockWithNotify(x, y, z, getBurnResultId(world, x, y, z));
+		} else {
+			world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+		}
+	}
+	public void ignite(final World world, final int x, final int y, final int z) {
+		boolean hasCreatedFire = false;
+		if (!hasCreatedFire) {
+			hasCreatedFire = this.tryIgnite(world, x, y + 1, z);
+		}
+		if (!hasCreatedFire) {
+			hasCreatedFire = this.tryIgnite(world, x - 1, y, z);
+		}
+		if (!hasCreatedFire) {
+			hasCreatedFire = this.tryIgnite(world, x + 1, y, z);
+		}
+		if (!hasCreatedFire) {
+			hasCreatedFire = this.tryIgnite(world, x, y, z - 1);
+		}
+		if (!hasCreatedFire) {
+			hasCreatedFire = this.tryIgnite(world, x, y, z + 1);
+		}
+		if (!hasCreatedFire) {
+			hasCreatedFire = this.tryIgnite(world, x, y - 1, z);
+		}
+		if (!hasCreatedFire) {
+			world.setBlock(x, y, z, Blocks.FIRE.id);
+		}
+	}
+	private boolean tryIgnite(final World world, final int x, final int y, final int z) {
+		final int tile = world.getBlockId(x, y, z);
+		if (tile == Blocks.FIRE.id) {
+			return true;
+		}
+		if (tile == 0) {
+			world.setBlock(x, y, z, Blocks.FIRE.id);
+			return true;
+		}
+		return false;
+	}
+
+	@Override
+	public void animationTick(World world, int x, int y, int z, Random rand) {
+		if (rand.nextInt(24) == 0) {
+			world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) x + 0.5F, (float) y + 0.5F, (float) z + 0.5F, "fire.fire",
+								  1.0F + rand.nextFloat(), rand.nextFloat() * 0.7F + 0.3F);
+		}
+		if (world.isBlockNormalCube(x, y - 1, z) || canBurn(world, x, y - 1, z)) {
+			for (int l = 0; l < 3; l++) {
+				double f = (double) x + rand.nextFloat();
+				double f6 = (double) y + rand.nextFloat() * 0.5F + 0.5F;
+				double f12 = (double) z + rand.nextFloat();
+				world.spawnParticle("largesmoke", f, f6, f12, 0.0D, 0.0D, 0.0D, 0);
+			}
+
+		} else {
+			if (canBurn(world, x - 1, y, z)) {
+				for (int i1 = 0; i1 < 2; i1++) {
+					double f1 = (double) x + rand.nextFloat() * 0.1F;
+					double f7 = (double) y + rand.nextFloat();
+					double f13 = (double) z + rand.nextFloat();
+					world.spawnParticle("largesmoke", f1, f7, f13, 0.0D, 0.0D, 0.0D, 0);
+				}
+
+			}
+			if (canBurn(world, x + 1, y, z)) {
+				for (int j1 = 0; j1 < 2; j1++) {
+					double f2 = (double) (x + 1) - rand.nextFloat() * 0.1F;
+					double f8 = (double) y + rand.nextFloat();
+					double f14 = (double) z + rand.nextFloat();
+					world.spawnParticle("largesmoke", f2, f8, f14, 0.0D, 0.0D, 0.0D, 0);
+				}
+
+			}
+			if (canBurn(world, x, y, z - 1)) {
+				for (int k1 = 0; k1 < 2; k1++) {
+					double f3 = (double) x + rand.nextFloat();
+					double f9 = (double) y + rand.nextFloat();
+					double f15 = (double) z + rand.nextFloat() * 0.1F;
+					world.spawnParticle("largesmoke", f3, f9, f15, 0.0D, 0.0D, 0.0D, 0);
+				}
+
+			}
+			if (canBurn(world, x, y, z + 1)) {
+				for (int l1 = 0; l1 < 2; l1++) {
+					double f4 = (double) x + rand.nextFloat();
+					double f10 = (double) y + rand.nextFloat();
+					double f16 = (double) (z + 1) - rand.nextFloat() * 0.1F;
+					world.spawnParticle("largesmoke", f4, f10, f16, 0.0D, 0.0D, 0.0D, 0);
+				}
+
+			}
+			if (canBurn(world, x, y + 1, z)) {
+				for (int i2 = 0; i2 < 2; i2++) {
+					double f5 = (double) x + rand.nextFloat();
+					double f11 = (double) (y + 1) - rand.nextFloat() * 0.1F;
+					double f17 = (double) z + rand.nextFloat();
+					world.spawnParticle("largesmoke", f5, f11, f17, 0.0D, 0.0D, 0.0D, 0);
+				}
+
+			}
+		}
+	}
+	
+}
